#!/bin/false


#   ┏━━━━━━━━━━━━━━━━━━━━━━━━━━━┓
#   ┃   DO NOT EDIT THIS FILE   ┃
#   ┗━━━━━━━━━━━━━━━━━━━━━━━━━━━┛


# This file contains utilities that can help you create directory trees.
# You will not find any tests here, however. Look for files named ‹test-*.sh›
# instead.



if [ -n "${_cli_test_utils+loaded}" ]; then
    return
fi

_cli_test_utils=1

_exe="${cli_script_bin}"/maze

maze() {
    timeout --kill-after 5 ${CLI_TEST_TIMEOUT:-30} \
        valgrind --log-file="$cli_stash/valgrind.log" --errors-for-leak-kinds=all \
        --leak-check=full --show-leak-kinds=all --track-fds=yes \
        "${_exe}" "$@"
}

exe="maze"

tests_init() {
    if [ ! -x "${_exe}" ]; then
        _cli_msg_fatal "Executable '${_exe}' not found"
    fi
}


stderr_not_empty() {
    output_type="$1"
    program_output="$2"

    if [ "${output_type}" = "stderr" ]; then
        # Check if stderr is not empty
        if ! [ -s "${program_output}" ]; then
            _cli_msg_fail "stderr is empty"
            return 1
        fi
    fi
}


maze_check() {
    ${exe} check "${cli_data}/$1"
}

maze_solve() {
    ${exe} solve "${cli_data}/$1" "output.out"

    if [ -e "output.out" ]; then
        cat "output.out"
    fi
}
